#define xy 10
#define cells xy*xy
#include <stdio.h>

volatile char matrix[xy][xy] = {' '};
volatile char countm[xy][xy] = {0};

void countLiving(int row, int column) {

  countm[row][column] = 0;
  /* above left */
  if ( !(row-1 < 0) && !(column-1 < 0) && matrix[row-1][column-1] != ' ') {
  	countm[row][column] += 1;
  }
  /* above middle */
  if ( !(row-1 < 0) && matrix[row-1][column] != ' ') {
  	countm[row][column] += 1;
  }
  /* above right */
  if ( !(row-1 < 0) && !(column+1 > xy) && matrix[row-1][column+1] != ' ') {
  	countm[row][column] += 1;
  }
  /* left */
  if ( !(column-1 < 0) && matrix[row][column-1] != ' ') {
  	countm[row][column] += 1;
  }
  /* don't count self */
  
  /* right */
  if ( !(column+1 > xy) && matrix[row][column+1] != ' ') {
  	countm[row][column] += 1;
  }
  /* below left */
  if ( !(row+1 < xy) && !(column-1 < 0) && matrix[row+1][column-1] != ' ') {
  	countm[row][column] += 1;
  }
  /* below middle */
  if ( !(row+1 < xy) && matrix[row+1][column] != ' ') {
  	countm[row][column] += 1;
  }
  /* below right */
  if ( !(row+1 < xy) && !(column+1 > xy) && matrix[row+1][column+1] != ' ') {
  	countm[row][column] += 1;
  }
  
  return;
}

void print_row_label(int i) {
  if ((i == 0) || (i == 5)) {
    printf("+");
  } else {
    printf("|");
  }
  return;
}

void print_matrix(void) {
  int i, j;
  printf("X+----+----X\n");
  for (i=0; i<xy; i++) {
	print_row_label(i);
    for (j=0; j<xy; j++) {
      printf("%c", matrix[i][j]);
    }
	print_row_label(i);
    printf("\n");
  }
  printf("X+----+----X\n");
}

void print_count(void) {
  int i, j;
  printf("X+----+----X\n");
  for (i=0; i<xy; i++) {
	print_row_label(i);
    for (j=0; j<xy; j++) {
      if (countm[i][j] == 0) {
      	printf(" ");
      } else {	
        printf("%i", countm[i][j]);
      }
    }
	print_row_label(i);
    printf("\n");
  }
  printf("X+----+----X\n");
}

void set_new(void) {
  int i, j;
  for (i=0; i<xy; i++) {
    for (j=0; j<xy; j++) {
      switch (countm[i][j]) {
      	case 3:
      	  matrix[i][j] = 'X';
      	  break;
      	case 2:
      	  /* maintain status quo */
      	  break;
      	default:
      	  matrix[i][j] = ' ';
      	  break;
      }
    }
  }
}

int main() {
  char                charBuf;
  int                 bytesRead = 0;
  int                 rc, stat;
  int                 i, j;
  int                 index;
  char                filename[7] = {'f','i','l','e','0','0',0};
  FILE               *infile;
  
  infile = fopen(filename, "rb");

  for (i=0; i<xy; i++) {
    for (j=0; j<xy; j++) {
      bytesRead = fread( &charBuf, sizeof( char ), 1, infile );
      if (bytesRead == 1) {
      	switch (charBuf) {
          case ' ':
          case '0':
  	        matrix[i][j] = ' ';
            break;
  	      default: 
  	        matrix[i][j] = 'X';
  	        break;
        }
      }
    }
  }
  fclose(infile);
  
  print_matrix();

  for (i=0; i<xy; i++) {
    for (j=0; j<xy; j++) {
      index = i * xy + j;
    
      countLiving(i, j);
    }
  }

  print_count();
  set_new();

  print_matrix();

  return(0);
}
